[VBA]Zwcad2023 - Błąd z lokalizacją względem obiektu - koło


Recommended Posts

Cześć, zauważyłem kolejny błąd w ZWCAD, proszę o pomoc w możliwościach.

Napisałem sobie taki prosty kod ze wstawieniem bloku. Blok posiada okrąg i atrybuty. Zauważyłem, że po kolejnym wstawieniu bloku lokalizacja względem obiektu - kwadrant koła - przestaje działać na bloku. Wszystko przedstawia poniższy filmik. Kod:

Private Sub CommandButton1_Click()
UserForm1.hide
Dim BlockRef As ZcadBlockReference
Dim BlockAttributes As Variant
Dim PIERWSZY As Variant
Dim FileToInsert As String

PIERWSZY = ThisDrawing.Utility.GetPoint(, "Podaj punkt P1")
FileToInsert = "C:\e-cad\e-cad Zelbet Stal Drewno\Bloki\Opisy\e-cad_ZelbetOpis_7.dwg"
Set BlockRef = ThisDrawing.ModelSpace.InsertBlock(PIERWSZY, FileToInsert, 1, 1, 1, 0)
  BlockAttributes = BlockRef.GetAttributes
  BlockAttributes(0).TextString = "blok"
BlockRef.Update
Exit Sub
End Sub

(W kodzie dodałem na końcu Exit Sub, bo myślałem, że obiekt gdzieś wiruje w tle ale to nic nie dało. W filmiku tego Exit Sub nie było)

Filmik: 

http://cloud.movavi.com/show/47b0ff05-a0a5-4862-8df1-0a48f3990d14

Link to comment
Share on other sites

  • 1 month later...

Otrzymałem informacje z ZWSoft myśl których w kodzie po

BlockRef.Update

potrzebne jest dodanie

Dim ent  As ZcadEntity
Dim blkref As ZcadBlockReference
For Each ent In ThisDrawing.ModelSpace
	If TypeOf ent Is ZcadBlockReference Then
        Set blkref = ent
        If blkref.Name = "e-cad_ZelbetOpis_7" Then
	        ent.Update
        End If
    End If
Next
Link to comment
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

Loading...